<?php
// +----------------------------------------------------------------------
// | 启动监控
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

ignore_user_abort(true); // 后台运行
set_time_limit(0); // 取消脚本运行时间的超时上限

// 验证安装
$DIR = dirname(__DIR__);
$DS = DIRECTORY_SEPARATOR;
require_once $DIR.$DS.'Callback.php';
require_once $DIR.$DS.'vendor'.$DS.'function.php';
require_once $DIR.$DS.'vendor'.$DS.'Sql.php';
require_once $DIR.$DS.'vendor'.$DS.'Db.php';

$pid = getmypid();
$myfile = fopen($DIR.$DS.'pid', "w") or die("无法写入进程ID");
fwrite($myfile, $pid);
fclose($myfile);

$table_create_sql = file_get_contents($DIR.$DS.'vendor'.$DS.'table_create.sql');

$obj = new Sql();
$Db = new Db();

$config = include $DIR.$DS.'database.php';

$shell = 'ps -ef | grep php | wc -l'."\n";
$shell .= "mysql -h".$config['hostname']." -u".$config['username']." -p".$config['password']." -e 'show processlist' | wc -l\n";
$shell .= "sar -n DEV 1 1";

//每隔一定时间运行 (实际上是会多1秒)
$interval=1;
$k = 0;
do {
    $opt = array();
    exec($shell, $opt, $return_val);
    $num = 0;
    $time = date('Ym', time());
    $table_mysql = 'mysql_'.$time;
    $table_php = 'php_'.$time;
    $table_network_entrance = 'network_entrance_'.$time;
    $table_network_exitus = 'network_exitus_'.$time;

    $list = select($Db, 'select * from information_schema.TABLES where TABLE_NAME = "niu_'.$table_mysql .'";');
    if (empty($list)) {
        // 创建月为单位
        $sql = str_replace('{}', date('Ym'), $table_create_sql);
        $Db->exec($sql);
    }

    foreach ($opt as $k=>$v) {
        if ($k == 0) {
            // PHP-FPM
            $sql = $obj->name($table_php)->insert(array('num' => $v, 'create_time'=>time()));
            $res = $Db->exec($sql);

            $sql = $obj->name('rule')->where('type', 2)->where('max <= '.$v)->order('max ASC')->select();
            $list = select($Db, $sql);
            if ($list) {
                foreach ($list as $val) {
                    Callback($val, $v);
                }
            }
            continue;
        } else if ($k == 1) {
            // Mysql
            $sql = $obj->name($table_mysql)->insert(array('num' => $v, 'create_time'=>time()));
            $res = $Db->exec($sql);
            
            $sql = $obj->name('rule')->where('type', 1)->where('max <= '.$v)->order('max ASC')->select();
            $list = select($Db, $sql);
            if ($list) {
                foreach ($list as $val) {
                    Callback($val, $v);
                }
            }
            continue;
        }
        if (empty($v)) {
            $num++;
            continue;
        }
        if ($num == 2) {
            $num++;
            continue;
        }
        if ($num == 3) {
            $v = preg_replace("/\s(?=\s)/","\\1",$v);
            $arr = explode(' ', $v);
            if (!empty($arr[1])) {
                $network = $arr[1];
                // 网卡ID
                $sql = $obj->name('network')->where('name = "'.$network.'"')->select();
                $list = select($Db, $sql);
                foreach ($list as $v) {
                    // 入口
                    $entrance = $arr[4];
                    $sql = $obj->name($table_network_entrance)->insert(array('pid'=>$v['id'], 'num' => $entrance, 'create_time'=>time()));
                    $Db->exec($sql);
                            
                    $sql = $obj->name('rule')->where('type', 4)->where('max <= '.$entrance)->order('max ASC')->select();
                    $list = select($Db, $sql);
                    if ($list) {
                        foreach ($list as $val) {
                            Callback($val, $entrance);
                        }
                    }
                    // 出口
                    $exitus = $arr[5];
                    $sql = $obj->name($table_network_exitus)->insert(array('pid'=>$v['id'], 'num' => $exitus, 'create_time'=>time()));
                    $Db->exec($sql); 

                    $sql = $obj->name('rule')->where('type', 3)->where('max <= '.$exitus)->order('max ASC')->select();
                    $list = select($Db, $sql);
                    if ($list) {
                        foreach ($list as $val) {
                            Callback($val, $exitus);
                        }
                    }
                }
            }
        }
    }
    // $k++;
    // if ($k > 30) {
    //     break;
    // }
    //等待时间，进行下一次操作。
    sleep($interval);
} while(true);