<?php
// +----------------------------------------------------------------------
// | 警告规则列表
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

// 验证安装
$DIR = dirname(__DIR__);
$DS = DIRECTORY_SEPARATOR;
require_once $DIR.$DS.'vendor'.$DS.'is_install.php';
require_once $DIR.$DS.'vendor'.$DS.'is_login.php';
require_once $DIR.$DS.'vendor'.$DS.'function.php';
require_once $DIR.$DS.'vendor'.$DS.'Sql.php';
require_once $DIR.$DS.'vendor'.$DS.'Db.php';

$obj = new Sql();
$Db = new Db();

$sql = $obj->name('rule')->order('type ASC, max ASC')->select();
$list = select($Db, $sql);
$count = count($list);

foreach ($list as $k=>$v) {
    $list[$k]['create_time'] = date('Y-m-d H:i:s', $v['create_time']);

    switch ($v['type']) {
        case 1: $list[$k]['type'] = 'MySql'; break;
        case 2: $list[$k]['type'] = 'PHP-FPM'; break;
        case 3: $list[$k]['type'] = '出口流量'; break;
        case 4: $list[$k]['type'] = '入口流量'; break;
    }
}

echo Jsonlist('0', '', $count, $list);