SET FOREIGN_KEY_CHECKS=0;

-- ----------------------------
-- Table structure for niu_network
-- ----------------------------
DROP TABLE IF EXISTS `niu_network`;
CREATE TABLE `niu_network` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(32) DEFAULT NULL COMMENT '网卡名称',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='网卡表';

-- ----------------------------
-- Records of niu_network
-- ----------------------------

-- ----------------------------
-- Table structure for niu_rule
-- ----------------------------
DROP TABLE IF EXISTS `niu_rule`;
CREATE TABLE `niu_rule` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `type` tinyint(1) DEFAULT NULL COMMENT '1.Mysql 2.PHP 3.出口流量 4.入口流量',
  `max` int(11) DEFAULT NULL COMMENT '警告值',
  `des` varchar(512) DEFAULT NULL COMMENT '自定义回调内容',
  `phone` varchar(32) DEFAULT NULL COMMENT '手机号',
  `email` varchar(32) DEFAULT NULL COMMENT '邮箱',
  `create_time` int(11) DEFAULT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM AUTO_INCREMENT=1 DEFAULT CHARSET=utf8 COMMENT='警告规则表';
