<?php
// +----------------------------------------------------------------------
// | 登录
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

// 验证安装
require_once __DIR__.DIRECTORY_SEPARATOR.'vendor'.DIRECTORY_SEPARATOR.'is_install.php';
?>

<!DOCTYPE html>
<html lang="zh">
<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no" />
<title>管理登陆</title>
<link href="public/bootstrap.css" rel="stylesheet" type="text/css" />
<link href="public/style.min.css" rel="stylesheet" type="text/css" />
<!--依赖JQ-->
<script src="public/jquery.min.js"></script>
<!--引入captcha SDK-->
<script type="text/javascript" src="https://blog.junphp.com/api/geetest_captcha/php/junphp_geetest_captcha.js"></script>
<!--引入captcha css SDK-->
<link href="https://blog.junphp.com/api/geetest_captcha/php/junphp_geetest_captcha.css" rel="stylesheet">

<style>
  body {
      display: -webkit-box;
      display: flex;
      -webkit-box-pack: center;
      justify-content: center;
      -webkit-box-align: center;
      align-items: center;
      height: 100%;
  }
  .login-box {
      display: table;
      table-layout: fixed;
      overflow: hidden;
      max-width: 700px;
  }
  .login-left {
      display: table-cell;
      position: relative;
      margin-bottom: 0;
      border-width: 0;
      padding: 45px;
  }
  .login-left .form-group:last-child {
      margin-bottom: 0px;
  }
  .login-right {
      display: table-cell;
      position: relative;
      margin-bottom: 0;
      border-width: 0;
      padding: 45px;
      width: 50%;
      max-width: 50%;
      background: #67b26f!important;
      background: -moz-linear-gradient(45deg,#67b26f 0,#4ca2cd 100%)!important;
      background: -webkit-linear-gradient(45deg,#67b26f 0,#4ca2cd 100%)!important;
      background: linear-gradient(45deg,#67b26f 0,#4ca2cd 100%)!important;
      filter: progid:DXImageTransform.Microsoft.gradient( startColorstr='#67b26f', endColorstr='#4ca2cd', GradientType=1 )!important;
  }
  .login-box .has-feedback.feedback-left .form-control {
      padding-left: 38px;
      padding-right: 12px;
  }
  .login-box .has-feedback.feedback-left .form-control-feedback {
      left: 0;
      right: auto;
      width: 38px;
      height: 38px;
      line-height: 38px;
      z-index: 4;
      color: #dcdcdc;
  }
  .login-box .has-feedback.feedback-left.row .form-control-feedback {
      left: 15px;
  }
  #title {
      display: none;
  }  
  @media (max-width: 576px) {
    .login-right {
        display: none;
    } 
    #title {
        display: block;
    }    
  }
  </style>
</head>

<body style="background-image: url(public/login-bg-3.jpg); background-size: cover;">


  <div class="bg-translucent p-10">
    <div class="login-box bg-white clearfix">
      <div class="login-left">
        <form id="myForm">
          <div class="form-group has-feedback feedback-left" id="title">
            <p style="font-size: 22px;color: #33cabb;margin-top: -10px">小黄牛监控系统</p>
          </div>
          <div class="form-group has-feedback feedback-left">
            <input type="text" placeholder="账号" class="form-control" name="username" />
          </div>
          <div class="form-group has-feedback feedback-left">
            <input type="password" placeholder="密码" class="form-control" name="userpwd" />
          </div>
          <div class="form-group has-feedback feedback-left">
            <div class="junphp_geetest_captcha"></div>
          </div>
          <div class="form-group">
            <button class="btn btn-block btn-primary" type="button" >立即登录</button>
          </div>
        </form>
      </div>

      <div class="login-right">
        <p style="font-size: 22px;color: #fff;">小黄牛监控系统</p>
        <p class="text-white m-tb-15">小黄牛博客</p>
        <p class="text-white">Copyright @ 2020-2020 blog.junphp.com 版权所有 </p>
      </div>
      
    </div>
  </div>

</body>
</html>
<!--消息提示-->
<script src="public/bootstrap-notify.min.js"></script>
<script type="text/javascript" src="public/lightyear.js"></script>
<script>
  $(".btn-primary").click(function () {
    var data = new FormData($("#myForm")[0]);
    $.ajax({
        type: 'post',
        data: data,
        async: false,
        cache: false,
        contentType: false,
        processData: false,
        url: "php/vif.php",
        success: function(data) {
          var array = eval('('+data+')');
          if (array['code'] == '00') {
            lightyear.notify(array['msg'], 'success', 1000);
            setTimeout(function () {
              window.location.href="index.php";
            },1000)
          } else {
            lightyear.notify(array['msg'], 'danger', 1000);
            junphp_vif_captcha();
          }
        }
    });
  
    return false;
  })
</script>