<?php
// +----------------------------------------------------------------------
// | 获取网卡入口数据
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

// 验证安装
$DIR = dirname(__DIR__);
$DS = DIRECTORY_SEPARATOR;
require_once $DIR.$DS.'vendor'.$DS.'is_install.php';
require_once $DIR.$DS.'vendor'.$DS.'is_login.php';
require_once $DIR.$DS.'vendor'.$DS.'function.php';
require_once $DIR.$DS.'vendor'.$DS.'Sql.php';
require_once $DIR.$DS.'vendor'.$DS.'Db.php';

$date  = array();
$list1 = array();
$list2 = array();

$start = time();
$table = 'network_entrance_'.date('Ym', time());
$obj = new Sql();
$Db = new Db();


// 时间查询
if (!empty($_POST['start']) && !empty($_POST['end'])) {
    $s1 = date('Ym', strtotime($_POST['start']));
    $s2 = date('Ym', strtotime($_POST['end']));
    if ($s1 != $s2) {
        Json('01', '只允许查询同一月份内的记录');
    }

    $s = strtotime($_POST['end'])-strtotime($_POST['start']);
    $start = strtotime($_POST['start']);
    $end = strtotime($_POST['end']);
    $start2 = $start - $s;
    $end2 = $end - $s;
    $sql = $obj->name($table)->where('create_time >= '.$start.' AND create_time <= '.$end)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $k=>$v) {
            if($k%80==0){
                $date[] = date('d日 H:i',$v['create_time']);
                $list1[] = $v['num'];
            }
        }
    }
    $sql = $obj->name($table)->where('create_time >= '.$start2.' AND create_time <= '.$end)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $k=>$v) {
            if($k%80==0){
                $list2[] = $v['num'];
            }
        }
    }
// 最近1分钟
} else if ($_POST['type'] == 1) {
    // $start = 1597476084;
    $end = $start-60;
    $start2 = $start - 86400;
    $end2 = $end - 86400;
    $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$end.' AND create_time <= '.$start)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $v) {
            $date[] = date('i:s',$v['create_time']);
            $list1[] = $v['num'];
        }
    }
    $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$end2.' AND create_time <= '.$start2)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $v) {
            $list2[] = $v['num'];
        }
    }
// 最近5分钟
} else if ($_POST['type'] == 2) { 
    // $start = 1597476084;
    $end = $start-(60*5);
    $start2 = $start - 86400;
    $end2 = $end - 86400;
    $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$end.' AND create_time <= '.$start)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $k=>$v) {
            if($k%2==0){
                $date[] = date('H:i:s',$v['create_time']);
                $list1[] = $v['num'];
            }
        }
    }
    $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$end2.' AND create_time <= '.$start2)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $k=>$v) {
            if($k%2==0){
                $list2[] = $v['num'];
            }
        }
    }
// 最近15分钟
} else if ($_POST['type'] == 3) { 
    // $start = 1597476084;
    $end = $start-(60*15);
    $start2 = $start - 86400;
    $end2 = $end - 86400;
    $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$end.' AND create_time <= '.$start)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $k=>$v) {
            if($k%5==0){
                $date[] = date('H:i:s',$v['create_time']);
                $list1[] = $v['num'];
            }
        }
    }
    $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$end2.' AND create_time <= '.$start2)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $k=>$v) {
            if($k%5==0){
                $list2[] = $v['num'];
            }
        }
    }
// 最近30分钟
} else if ($_POST['type'] == 4) { 
    // $start = 1597476084;
    $end = $start-(60*30);
    $start2 = $start - 86400;
    $end2 = $end - 86400;
    $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$end.' AND create_time <= '.$start)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $k=>$v) {
            if($k%10==0){
                $date[] = date('H:i:s',$v['create_time']);
                $list1[] = $v['num'];
            }
        }
    }
    $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$end2.' AND create_time <= '.$start2)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $k=>$v) {
            if($k%10==0){
                $list2[] = $v['num'];
            }
        }
    }
// 最近1小时
} else if ($_POST['type'] == 5) { 
    // $start = 1597476084;
    $end = $start-(60*60);
    $start2 = $start - 86400;
    $end2 = $end - 86400;
    $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$end.' AND create_time <= '.$start)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $k=>$v) {
            if($k%20==0){
                $date[] = date('H:i:s',$v['create_time']);
                $list1[] = $v['num'];
            }
        }
    }
    $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$end2.' AND create_time <= '.$start2)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $k=>$v) {
            if($k%20==0){
                $list2[] = $v['num'];
            }
        }
    }
// 最近3小时
} else if ($_POST['type'] == 6) { 
    // $start = 1597476084;
    $end = $start-(60*60*3);
    $start2 = $start - 86400;
    $end2 = $end - 86400;
    $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$end.' AND create_time <= '.$start)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $k=>$v) {
            if($k%40==0){
                $date[] = date('H:i',$v['create_time']);
                $list1[] = $v['num'];
            }
        }
    }
    $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$end2.' AND create_time <= '.$start2)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $k=>$v) {
            if($k%40==0){
                $list2[] = $v['num'];
            }
        }
    }
// 最近6小时
} else if ($_POST['type'] == 7) { 
    // $start = 1597476084;
    $end = $start-(60*60*6);
    $start2 = $start - 86400;
    $end2 = $end - 86400;
    $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$end.' AND create_time <= '.$start)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $k=>$v) {
            if($k%80==0){
                $date[] = date('H:i',$v['create_time']);
                $list1[] = $v['num'];
            }
        }
    }
    $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$end2.' AND create_time <= '.$start2)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $k=>$v) {
            if($k%80==0){
                $list2[] = $v['num'];
            }
        }
    }
// 最近12小时
} else if ($_POST['type'] == 8) { 
    // $start = 1597476084;
    $end = $start-(60*60*12);
    $start2 = $start - 86400;
    $end2 = $end - 86400;
    $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$end.' AND create_time <= '.$start)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $k=>$v) {
            if($k%160==0){
                $date[] = date('H:i',$v['create_time']);
                $list1[] = $v['num'];
            }
        }
    }
    $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$end2.' AND create_time <= '.$start2)->select();
    $list = select($Db, $sql);
    if ($list) {
        foreach ($list as $k=>$v) {
            if($k%160==0){
                $list2[] = $v['num'];
            }
        }
    }
// 最近一天
} else if ($_POST['type'] == 9) { 
    // $start = 1597476084;
    $end = $start;
    $start2 = $start - 86400;
    $end2 = $start2;

    for ($i=0; $i<24; $i++) {
        if ($i > 0) {
            $start = $end;
            $start2 = $end2;
        }
        $end  = $start+3600;
        $end2 = $start2+3600;
        $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$start.' AND create_time <= '.$end)->order('num DESC')->limit(1)->select();
        $list = select($Db, $sql);
        if ($list) {
            $date[] = date('d日H时', $start);
            foreach ($list as $k=>$v) {
                $list1[] = $v['num'];
            }
        }
        $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$start2.' AND create_time <= '.$end2)->order('num DESC')->limit(1)->select();
        $list = select($Db, $sql);
        if ($list) {
            foreach ($list as $k=>$v) {
                $list2[] = $v['num'];
            }
        }
    }
// 最近一周
} else if ($_POST['type'] == 10) { 
    // $start = 1597476084;
    $end = $start;
    $start2 = $start - (86400*7);
    $end2 = $start2;

    $time = ceil((86400*7) / 30);
    for ($i=0; $i<30; $i++) {
        if ($i > 0) {
            $start = $end;
            $start2 = $end2;
        }
        $end  = $start+$time;
        $end2 = $start2+$time;
        $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$start.' AND create_time <= '.$end)->order('num DESC')->limit(1)->select();
        $list = select($Db, $sql);
        if ($list) {
            $date[] = date('d日H时', $start);
            foreach ($list as $k=>$v) {
                $list1[] = $v['num'];
            }
        }
        $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$start2.' AND create_time <= '.$end2)->order('num DESC')->limit(1)->select();
        $list = select($Db, $sql);
        if ($list) {
            foreach ($list as $k=>$v) {
                $list2[] = $v['num'];
            }
        }
    }
// 最近一个月
} else if ($_POST['type'] == 11) { 
    // $start = 1597476084;
    $end = $start;
    $start2 = $start - (86400*30);
    $end2 = $start2;

    $time = ceil((86400*30) / 30);
    for ($i=0; $i<30; $i++) {
        if ($i > 0) {
            $start = $end;
            $start2 = $end2;
        }
        $end  = $start+$time;
        $end2 = $start2+$time;
        $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$start.' AND create_time <= '.$end)->order('num DESC')->limit(1)->select();
        $list = select($Db, $sql);
        if ($list) {
            $date[] = date('d日H时', $start);
            foreach ($list as $k=>$v) {
                $list1[] = $v['num'];
            }
        }
        $sql = $obj->name($table)->where('pid = '.$_POST['pid'].' AND create_time >= '.$start2.' AND create_time <= '.$end2)->order('num DESC')->limit(1)->select();
        $list = select($Db, $sql);
        if ($list) {
            foreach ($list as $k=>$v) {
                $list2[] = $v['num'];
            }
        }
    }
}
Json('00', '获取成功', array(
    'date' => $date, 
    'list1' => $list1, 
    'list2' => $list2, 
));